---
title: Pull request template
---

## Description

Describe the big picture of your changes here to communicate to the maintainers why the pull/merge request should be accepted. If it fixes a bug or resolves a feature request, be sure to link to that issue.

## How to test?

Please describe in detail how you tested your changes. Include details of your testing environment, and the tests you ran to see how your change affects other areas of the code, etc.

## Screenshots

If applicable, add screenshots (animated GIFs and images) that show your code in action.

## Changes include

- [ ] Bugfix (non-breaking change that solves an issue)
- [ ] New feature (non-breaking change that adds functionality)
- [ ] Breaking change (change that is not backwards-compatible and/or changes current functionality)

## Checklist

- [ ] The code follows the code style of this project
- [ ] Lint and unit tests pass locally with my changes
- [ ] Code contains tests relevant to the problem it solves
- [ ] All new and existing tests are passing
- [ ] Feature flag was added
- [ ] Necessary documentation was added (if appropriate)
- [ ] The code builds and runs

## Other comments

If this is a relatively large or complex change, kick off the discussion by explaining why you chose the solution you did and what alternatives you considered, etc...
